# std::basic_istream< _CharT, _Traits >::sentry Class Reference

List of all members.

## Detailed Description

### template<typename _CharT, typename _Traits>
class std::basic_istream< _CharT, _Traits >::sentry

Objects of this class are created before all of the standard extractors are run. It is responsible for "exception-safe prefix and suffix operations," although only prefix actions are currently required by the standard. Additional actions may be added by the implementation, and we list them in http://gcc.gnu.org/onlinedocs/libstdc++/17_intro/howto.html#5 under [27.6] notes.

Definition at line 646 of file istream.

## Public Types

- typedef __istream_type::__ctype_type __ctype_type
- typedef _Traits::int_type __int_type
- typedef basic_istream< _CharT,
  _Traits > __istream_type
- typedef basic_streambuf< _CharT,
  _Traits > __streambuf_type
- typedef _Traits traits_type

## Public Member Functions

- operator bool () const
- sentry (basic_istream< _CharT, _Traits > &__is, bool __noskipws=false)

## Member Typedef Documentation

template<typename _CharT, typename _Traits>

typedef _Traits std::basic_istream< _CharT, _Traits >::sentry::traits_type

Easy access to dependant types.

Definition at line 650 of file istream.

## Constructor & Destructor Documentation

template<typename _CharT, typename _Traits>

std::basic_istream< _CharT, _Traits >::sentry::sentry | ( | basic_istream< _CharT, _Traits > & | __is,
|  | bool | __noskipws = `false` |
| ) |  |  | `[explicit]`

The constructor performs all the work.

Parameters:

  | is | The input stream to guard.
  | noskipws | Whether to consume whitespace or not.

If the stream state is good (is.good() is true), then the following actions are performed, otherwise the sentry state is false ("not okay") and failbit is set in the stream state.

The sentry's preparatory actions are:

1. if the stream is tied to an output stream, `is.tie()->flush()` is called to synchronize the output sequence
2. if noskipws is false, and `ios_base::skipws` is set in `is.flags()`, the sentry extracts and discards whitespace characters from the stream. The currently imbued locale is used to determine whether each character is whitespace.

If the stream state is still good, then the sentry state becomes true ("okay").

Definition at line 53 of file istream.tcc.

References std::__check_facet(), std::__ctype_abstract_base< _CharT >::is(), std::basic_streambuf< _CharT, _Traits >::sgetc(), std::skipws(), and std::basic_streambuf< _CharT, _Traits >::snextc().

## Member Function Documentation

template<typename _CharT, typename _Traits>

std::basic_istream< _CharT, _Traits >::sentry::operator bool | ( |  | ) | const`[inline]`

Quick status checking.

Returns:
  The sentry state.

For ease of use, sentries may be converted to booleans. The return value is that of the sentry state (true == okay).

Definition at line 687 of file istream.

The documentation for this class was generated from the following files:

- istream
- istream.tcc